# PuzzleFW - Custom firmware for the Red Pitaya

This project provides an alternative, unofficial firmware package
for the Red Pitaya.
It consists of FPGA firmware and embedded software which can be installed on
the SD card in place of the official Red Pitaya firmware.

Red Pitaya is a signal processing board based on the Xilinx Zynq architecture.
See <https://redpitaya.com/> for further information.

PuzzleFW is very different from the official Red Pitaya firmware.
Its functionality is quite limited.
It is not aimed at exploration.
It doesn't have a web interface or any graphical interface.
Instead, it is designed to be controlled by other software via the network,
as part of an automated measurement setup.

PuzzleFW has the following features:

- Analog input at 125 MSa/s with optional downsampling.
- Triggered data acquisition via a digital input signal.
- Fast re-triggering, up to 100 kHz trigger rate.
- No analog output.
- Digital input with event timestamping (4 channels).
- Streaming transfer of sample data via TCP, up to 5 MSa/s.
- Remote control by sending commands via TCP.

Further details about the firmware are in these documents:

- [User manual](doc/user_manual.md)
- [Developer manual](doc/devel_manual.md), including build procedure
- [FPGA firmware description](doc/fpga_firmware.md)

## Supported boards

This firmware is currently compatible with the following boards:

- Red Pitaya STEMlab 125-14
- Red Pitaya STEMlab 125-14 4-input

## Status

The firmware works and has been tested and is being used on a small scale.

You are very welcome to use this firmware on your own Red Pitaya.
However, no support is available for this package.
This is currently just a side-project for me.
I don't have plans to develop this into a maintained product.

If you run into issues or discover bugs, I would like to hear about it.
But I can not guarantee that I will fix the problem.

You can contact me via email to `joris@jorisvr.nl`.

## License

The FPGA firmware and software in this repository are provided as free software under the terms of the GNU General Public License.

    Copyright (c) 2024 Joris van Rantwijk

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

